### include guard
(return 0 2>/dev/null)       &&
[[ -z ${FULLUP_LOG_SH_+1} ]] &&
declare -xr FULLUP_LOG_SH_=1 && {
###

dbg()
{
	local -r pfx="${BASH_SOURCE[2]:+${FUNCNAME[1]}}"
	local -r fmt="%s${pfx:+${1:+: }}${1}\n"
	printf "${fmt}" "${pfx}" "${@:2}" >&2
}

if (( NO_COLOR )); then
	msg() { printf "${1}"'\n' "${@:2}" >&2; }
	readonly __red=''
	readonly __yel=''
	readonly __eol=$'\n'
else
	msg() { printf '\e[38;5;117m'"${1}"'\e[m\n' "${@:2}" >&2; }
	readonly __red=$'\e[1;31m'
	readonly __yel=$'\e[1;33m'
	readonly __eol=$'\e[m\n'
fi

wrn() {
	if (( $# > 1 )); then
		printf "${__yel}W: $1$__eol" "${@:2}" >&2
	else
		printf "${__yel}W: %s$__eol" "$1" >&2
	fi
}

err() {
	local x="${BASH_SOURCE[2]:+1 + }1"
	x="$__red${BASH_SOURCE[$x]##*/}: "
	if (( $# > 1 )); then
		printf "$x$1$__eol" "${@:2}" >&2
	else
		printf "$x%s$__eol" "${1:-error}" >&2
	fi
}

clear_tty1() {
	echo -en '\e[44m\e[2J\e[H' > /dev/tty1
}

newline() { echo >&2; }

### include guard
} || ((1))
###
